(HERALD (TSYS PRIMOPS T 63)
        (ENV () (TSYS OPEN) (TSYS ALIASES))
        (SYNTAX-TABLE
         (BLOCK (*REQUIRE 'GUARD '(TSYS GUARD) (THE-ENVIRONMENT))
                (ENV-SYNTAX-TABLE (THE-ENVIRONMENT)))))

;;; Copyright (c) 1983, 1984 Yale University

;;;; Primops

(DEFINE STRING-HEAD
  (MAKE-ACCESSOR
   (GUARDED-PRIMOP STRING-HEAD (NON-EMPTY-STRING?))
   (GUARDED-PRIMOP SET-STRING-HEAD (NON-EMPTY-STRING? CHAR?))))

(DEFINE STRING-ELT
  (MAKE-ACCESSOR
   (GUARDED-PRIMOP STRING-ELT
                   ((STR STRING?) (IDX NONNEGATIVE-FIXNUM?))
                   (FX< IDX (STRING-LENGTH STR)))
   (GUARDED-PRIMOP SET-STRING-ELT
                   ((STR STRING?) (IDX NONNEGATIVE-FIXNUM?) (CH CHAR?))
                   (FX< IDX (STRING-LENGTH STR)))))

(DEFINE-PRIMOP CHOPY (STRING?))
(DEFINE-PRIMOP CHOPY! (STRING? STRING?))

(DEFINE-PRIMOP STRING-TAIL! (NON-EMPTY-STRING?))

(DEFINE-PRIMOP STRING-NTHTAIL!
  ((STR STRING?) (IDX NONNEGATIVE-FIXNUM?))
  (FX<= IDX (STRING-LENGTH STR)))

(DEFINE-PRIMOP STRING-EMPTY? (STRING?))

(DEFINE EXTEND-ELT
  (MAKE-ACCESSOR (GUARDED-PRIMOP EXTEND-ELT (EXTEND? FIXNUM?))
                 (GUARDED-PRIMOP SET-EXTEND-ELT (EXTEND? FIXNUM? TRUE))))

(DEFINE SET-EXTEND-ELT (SETTER EXTEND-ELT))

(DEFINE-PRIMOP POINTER-TAG (TRUE))
(DEFINE-PRIMOP POINTER-ADDRESS (TRUE))

(DEFINE-PRIMOP MAKE-POINTER (FIXNUM?
                             (N (LAMBDA (N)
                                  (AND (NONNEGATIVE-FIXNUM? N) (FX< N 8))))))

(DEFINE NEW-CELL (PRIMOP-PROC NEW-CELL ()))
(DEFINE CONS     (PRIMOP-PROC CONS (A D)))
(DEFINE-PRIMOP MAKE-EXTEND (TEMPLATE? FIXNUM?))

(DEFINE HEAP-POINTER
  (MAKE-ACCESSOR (PRIMOP-PROC HEAP-POINTER ())
                 (PRIMOP-PROC SET-HEAP-POINTER (PTR))))

(DEFINE THE-SLINK
  (MAKE-ACCESSOR (PRIMOP-PROC THE-SLINK ())
                 (PRIMOP-PROC SET-THE-SLINK (PTR))))

;;; Low-level pointer converters.
(DEFINE-PRIMOP FIXNUM->POINTER (FIXNUM?))
(DEFINE-PRIMOP POINTER->FIXNUM (TRUE))
(DEFINE-PRIMOP CHAR->POINTER (CHAR?))
(DEFINE-PRIMOP POINTER->CHAR (TRUE))

(DEFINE-PRIMOP XENOID->FIXNUM (XENOID?))

(DEFINE (NO-OP X) X)                  ; Expressly for faking out TC.
